//Copyright 2008 Cold Spring Harbor Laboratory.
//Written by Yaniv Erlich (erlich@cshl.edu)



#include <gsl/gsl_ieee_utils.h>
#include <stdio.h>
#include <gsl/gsl_matrix.h>
#include <float.h>
//#define DEBUG 

//gcc : gcc $(gsl-config --cflags) SVD.c $(gsl-config --libs) -o svd

int main (int argc, char * argv[])
{
  gsl_ieee_env_setup (); /* read GSL_IEEE_MODE */

  //setting
  int m = atoi (argv [1]);
  int n = atoi (argv [2]);

  char *file_name = argv[3];

  gsl_matrix *Matrix =  gsl_matrix_alloc (m,n) ;
  gsl_matrix *U =  gsl_matrix_alloc (n,n) ; 
            //This is v but since we are working on the
            // tanspose it is u.
  gsl_matrix *w =  gsl_matrix_alloc (n,n) ;
            //Working matrix
  gsl_vector *D =  gsl_vector_alloc (n);
            // The transpose of the diagonal;
  gsl_vector *x =  gsl_vector_alloc (n);
            // Working vector;


  //preparing files
  FILE * matrix_file, *Uf, *Df, *Vf;
  if ( ! (matrix_file = fopen (file_name, "r")) ||
       ! (Uf = fopen (".u.del",  "w"))          ||
       ! (Df = fopen (".d.del",  "w"))          ||
       ! (Vf = fopen (".v.del",  "w")) 
                                                  ) {

     printf ("can't open file:%s\n",file_name);
     return 0;
  }




  //actual processing
  unsigned int lines = gsl_matrix_fscanf (matrix_file, Matrix);
            //Fills the rows and then the colums


  #ifdef DEBUG 
    printf("Input:\n");
    gsl_matrix_fprintf(stdout,Matrix,"%f");
    printf("\n");
  #endif
  double y = gsl_linalg_SV_decomp_mod (Matrix, w, U, D, x);

  gsl_matrix_fprintf(Vf,Matrix,"%.15f");
        //usually a stores U but we are working on
        //transpose;
  gsl_matrix_fprintf(Uf,U,"%.15f");
  gsl_vector_fprintf(Df,D,"%.15f");



 #ifdef DEBUG 
    printf("V:\n");
  gsl_matrix_fprintf(stdout,Matrix,"%.15f");
    printf("\n");
    printf("U:\n");
  gsl_matrix_fprintf(stdout,U,"%.15f");
    printf("\n");
    printf("D:\n");
  gsl_vector_fprintf(stdout,D,"%.15f");
    printf("\n");
 #endif

  return 1;
}

